/** load implement at very first time */
/**
 * global error catch
 */
import './events';
import './loader';

/**
 * @public Jolibox JS SDK Entry
 */
import { getSystemInfoSync, canIUse, login, checkSession } from './api';
import { RuntimeSDK } from './sdks/runtime';
import { LifecycleSDK } from './sdks/lifecycle';
import { StorageSDK } from './sdks/storage';
import { JoliboxAds } from './sdks/ads';
import { KeyboardSDK } from './sdks/keyboard';
import { TaskTrackerSDK } from './sdks/task';

declare global {
  interface Window {
    JoliboxSDK: typeof JoliboxSDK; // TODO: code review this @Dengxue
  }
}

export class JoliboxSDK {
  readonly jssdkVersion = '__JOLIBOX_LOCAL_SDK_VERSION__';
  readonly runtime = new RuntimeSDK();
  readonly ads = new JoliboxAds();
  readonly lifecycle = new LifecycleSDK();
  readonly storage = new StorageSDK();
  readonly keyboard = new KeyboardSDK();
  readonly task = new TaskTrackerSDK();

  //global API
  getSystemInfoSync = getSystemInfoSync.bind(this);
  canIUse = canIUse.bind(this);
  login = login.bind(this);
  checkSession = checkSession.bind(this);
}

window.JoliboxSDK = JoliboxSDK; // TODO: code review this @Dengxue
