import { BaseSDK } from './sdk';
import { Keyboard, ResponseType } from '@jolibox/types';

export class KeyboardSDK extends BaseSDK implements Keyboard {
  /**
   * 显示键盘
   * @param params
   * @returns
   */
  showKeyboard(params: { defaultValue?: string; maxLength?: number; multiple?: boolean }) {
    const errMsg = this.canIUseIfThrow('keyboard.showKeyboard');
    if (errMsg) {
      return errMsg;
    }
    this.commands.executeCommand('KeyboardSDK.showKeyboard', params);
  }
  /**
   * 更新键盘
   * @param value
   * @returns
   */
  updateKeyboard(value: string) {
    const errMsg = this.canIUseIfThrow('keyboard.updateKeyboard');
    if (errMsg) {
      return errMsg;
    }
    this.commands.executeCommand('KeyboardSDK.updateKeyboard', { value });
  }
  /**
   * 隐藏键盘
   * @returns
   */
  hideKeyboard() {
    const errMsg = this.canIUseIfThrow('keyboard.hideKeyboard');
    if (errMsg) {
      return errMsg;
    }
    this.commands.executeCommand('KeyboardSDK.hideKeyboard');
  }
}
